#!/usr/bin/perl

## Certification Approved Requests Program
## (c) 1999 by Massimiliano Pala
## All Rights are reserved.
##
## Released under the OpenCA Project.
##
##         Version : 0.001
##         Started : 05 Mar 1999
##

## Flush the Output
$|=1;

## Requirements
require 5.001;

## Modules used
use OpenCA::TRIStateCGI;

## include ENV file
## require "shell.OpenSSL";

## Get parameters from the Web
$tristate = new OpenCA::TRIStateCGI;

## Initialize HTML header
print "Content-type: text/html\n\n";

## Get the requestFileName
if ( ($fileName = $tristate->param('reqFile')) eq "") {
	my $err = "Error Accessing Certificate Request ($fileName)!";
	print $tristate->printError( 500, $err );
	exit 0;
}

## Sign the certificate
$SIGN_CERT = "/usr/local/ssl/bin/ssleay ca -verbose -batch -in ";
my $cmd = $SIGN_CERT . " $fileName 2>&1";
$ret = `$cmd`;

print $tristate->start_html( -title=>'Issuing Certificate Logging',
                -BGCOLOR=>'#FFFFFF' );
print "<PRE>$ret</PRE>";
print $tristate->end_html();

exit 0;


