#!/bin/perl

## Enrollment Program for CAFE ID Registration Center
##
##  GMD 1997 by Stephan Andr 
## Modified by Marco Gavelli
##
## Last Modified by Massimiliano Pala - Comune di Modena ( CA )
## (c) 1998 by Massimiliano Pala, All Rights Reserved.
##
## Project Modifying Started : 7 September 1998
##		       Ended :

## print "Content-type: text/html\n\n";

## read profile
require "enrollid_env.pl";


## Uses the signedCGI modules (c) 1998 by Massimiliano Pala
## to generate, check and manipulate FORMs Objects
use TRIStateCGI;

## Generate a new reference to signedCGI ( istance ) and a self reference
## to keep track of the URL this CGI is referring to (its own URL)
$tristate        = new TRIStateCGI;
$self            = $tristate->self_url;
$formFile        = 'forms/richiesta_cert.form';
$formFile2       = 'forms/conferma_cert.form';
$confirmFormFile = 'forms/richiesta_confirm.form';
$successPage     = 'messages/richiesta_successo.html';
$browserError    = 'messages/browser_error.html';

## Set the new variables for the Input elements and Checking values
@myparnames = ( '$operation','$newkey','$email','$first_name','$last_name','$org',
		'$country', '$passwd1','$passwd2','$passwd3','$sessionid','$newcert',
		'$servertype', '$authority', '$format' );

## Define the parameters values and general expressions
%par1 = (   -regx=>'*',
	    -intype=>'hidden',
	    -name=>'operation',
	    -value=>'client-filled-form');
%par2 = (   -regx=>'TEXT',
	    -intype=>'textfield',
	    -minlen=>6,
	    -name=>'newkey');
%par3 = (   -regx=>'EMAIL',
	    -intype=>'textfield',
	    -size=>30,
	    -name=>'email',
	    -minlen=>3);
%par4 = (   -regx=>'LETTERS',
	    -intype=>'textfield',
	    -name=>'first_name',
	    -size=>20,
	    -minlen=>2);
%par5 = (   -regx=>'LETTERS',
	    -intype=>'textfield',
	    -name=>'last_name',
	    -size=>20,
	    -minlen=>3);
%par6 = (   -regx=>'LETTERS',
	    -intype=>'popup_menu',
	    -name=>'org',
	    -values=>['Comune di Modena']);
%par7 = (   -regx=>'LETTERS',
	    -intype=>'popup_menu',
	    -name=>'country',
	    -values=>['IT']);
%par8 = (   -regx=>'*',
	    -intype=>'password_field',
	    -name=>'passwd1',
	    -size=>16,
	    -minlen=>10);
%par9 = (   -regx=>'*',
	    -intype=>'password_field',
	    -name=>'passwd2',
	    -size=>16,
	    -minlen=>10);
%par10 = (   -regx=>'*',
	    -intype=>'password_field',
	    -name=>'passwd3',
	    -minlen=>10);
%par11 = (  -regx=>'*',
	    -intype=>'textfield',
	    -name=>'sessionid');
%par12 = (  -regx=>'*',
	    -intype=>'textfield',
	    -name=>'newcert',
	    -minlen=>3);
%par13 = (  -regx=>'LETTERS',
	    -intype=>'textfield',
	    -name=>'servertype',
	    -minlen=>3);
%par14 = (   -regx=>'TEXT',
	    -intype=>'textfield',
	    -name=>'authority',
	    -minlen=>3);
%par15 = (   -regx=>'*',
	    -intype=>'textfield',
	    -name=>'format',
	    -minlen=>3);

## Generate the Parameters (Input Objects) : the names must match
## ones included in the form;
$operation  = $tristate->newInput ( %par1 );
$newkey     = $tristate->newInput ( %par2 );
$email      = $tristate->newInput ( %par3 );
$first_name = $tristate->newInput ( %par4 );
$last_name  = $tristate->newInput ( %par5 );
$org        = $tristate->newInput ( %par6 );
$country    = $tristate->newInput ( %par7 );
$passwd1    = $tristate->newInput ( %par8 );
$passwd2    = $tristate->newInput ( %par9 );
$passwd3    = $tristate->newInput ( %par10 );
$sessionid  = $tristate->newInput ( %par11 );
$newcert    = $tristate->newInput ( %par12 );
$servertype = $tristate->newInput ( %par13 );
$authority  = $tristate->newInput ( %par14 );
$format     = $tristate->newInput ( %par15 );

@myparams   = ( $operation, $newkey, $email, $first_name, $last_name,$org,
		$country, $passwd1, $passwd2, $passwd3, $sessionid, $newcert,
		$servertype, $authority, $format ); 

## Set the SECUDE LIBRARY PATH
## $ENV{LD_LIBRARY_PATH}= $__SECUDE__LIB;
## $ENV{LD_LIBRARY_PATH}= "/opt/secude";
$ENV{LD_LIBRARY_PATH}= "/usr/local/digid/secude";


## temporary files
$TMP_PSE  = 'pse' . $$;
$TMPFILE  = $__ENROLL__ . '.tmp' . $$;
$MIMEFILE = $__ENROLL__ . '.mime' . $$;
$DUMPFILE = $__ENROLL__ . '.dump' . $$;

## trace files
$ENROLLLOG = $__ENROLL__ . 'log';
$FORMFILE  = $__ENROLL__ . '.form';
$TRACEFILE = $__ENROLL__ . '.trc';

## official start page
$DOC_ROOT = $SERVER_ROOT . $URL_PREFIX;

## myself
$SCRIPT_NAME = $ENV{'SCRIPT_NAME'};

## allowed pages after cutting its root + prefix
$AUTH_URL	= $URL_PREFIX . '/authority.htm';
$PSE_URL	= $URL_PREFIX . '/pse_gen.htm';
$NS_URL		= $URL_PREFIX . '/cli/ns_cert.htm';
$IE_URL		= $URL_PREFIX . '/cli/ie_cert.htm';

## Product name
$PRODUCT_NAME = '';
$CERT_NAME    = 'Authority Certificate Installation';
$NS_NAME      = 'Netscape Navigator and Communicator';
$IE_NAME      = 'Microsoft Internet Explorer';
$SM_NAME      = 'S/MIME Enhanced Mail User Agent';
$PM_NAME      = 'PEM Enhanced Mail User Agent';
$EN_NAME      = 'Netscape Enterprise Server';
$II_NAME      = 'Microsoft Internet Information Server';
$AP_NAME      = 'Apache SSL Server';
$AL_NAME      = 'Computer Software Manufaktur Alibaba';
$WP_NAME      = 'O\'Reilly & Associates WebSite Pro';
$PSE_NAME     = 'SECUDE Personal Security Environment';


## Boundary lines
## outgoing Apache certificate
$APACHE_BEGIN_CERT	= "-----BEGIN CERTIFICATE-----\n";
$APACHE_END_CERT	= "-----END CERTIFICATE-----";

# outgoing Microsoft certificate (contain additional blank lines!)
$MICROSOFT_BEGIN_CERT	= "-----BEGIN IE CLIENT CERTIFICATE REQUEST-----\n";
$MICROSOFT_END_CERT	= "-----END IE CERTIFICATE REQUEST-----\n";

# Modifiche MG 
# outgoing Netscape certificate request
$NS_BEGIN_CERT_REQ = "-----BEGIN NETSCAPE CLIENT CERTIFICATE REQUEST-----\n";
$NS_END_CERT_REQ = "-----END NETSCAPE CLIENT CERTIFICATE REQUEST-----\n";

# outgoing IE certificate request
$IE_BEGIN_CERT_REQ = "-----BEGIN IE CLIENT CERTIFICATE REQUEST-----\n";
$IE_END_CERT_REQ = "-----END IE CLIENT CERTIFICATE REQUEST-----\n";

# outgoing Netscape pub key
$NS_BEGIN_PK = "-----BEGIN PUBKEY-----\n";
$NS_END_PK = "-----END PUBKEY-----\n";

#Minima lunghezza della PASSWORD (PIN)
$MIN_PASS_LENGHT=10;

## Check parameters, make reqs for Certificates and so on, depending on the
## CGI status contained in the $OPERATION variable ( below )
##
## Also TRACE the remote host in the logfile ( named $ENROLLLOG ).

## Flush the Output Stream
$| = 1;

## Begin Logging the Remote Host
$USER_AGENT = $tristate -> user_agent();

## Get the Browser Name and the Version
if ( $USER_AGENT =~ /(MSIE)/ ) {
($browser, $ver) =
	$USER_AGENT =~ /(MSIE)\ (\d+\.\d*|\.\d+)/;
} else {
($browser, $ver) =
	$USER_AGENT =~ m-(^[^/]+)/(\d+\.\d*|\.\d+)-;
};


if( $tristate->param('operation') eq "") {
    &printFormOne();
    exit;   
} 

## Check Environment Settings
$HTTP_REFERER = $tristate -> referer();
$METHOD = $tristate->request_method();

## Check FORM : try to identify if the form has already been
## completed and needs confirmation or if we are in the earlier
## status ( checking for the correct parameters )

## Status of FORM, possible values (in this order):
##	'client-filled-form' | 'client-confirmed-form'
## 	'pse-filled-form'    | 'pse-confirmed-form'
## 	'server-filled-form' | 'server-confirmed-form'
## 	'pem-filled-form'    | 'pem-confirmed-form'
## 	'authority-form'
$OPERATION = $tristate->param('operation');
$NEWKEY    = $tristate->param('newkey');
$EMAIL     = $tristate->param('email');

## Client & PSE request only : get personal data from the in-form
## $NAME = split $FORM{'name'};		
## $FIRST_NAME = join " ", grep {$_ = ucfirst lc $_} split /\s+/, $FORM{'first_name'};            
## $LAST_NAME = join " ", grep {$_ = ucfirst lc $_} split /\s+/, $FORM{'last_name'};		# Client & PSE request only

$FIRST_NAME = $tristate->param('first_name');
$LAST_NAME = $tristate->param('last_name');

# Client & PSE request only
$NAME		= $FIRST_NAME . " ". $LAST_NAME ;
$ORG            = $tristate->param('org');
$COUNTRY	= $tristate->param('country');
$PASSWD		= $tristate->param('passwd1');
$PASSWD2	= $tristate->param('passwd2');
$PASSWD3	= $tristate->param('passwd3');

## MSIE client-confirmed-form only
$SESSIONID	= $tristate->param('sessionid');

## Server request only
$NEWCERT	= $tristate->param('newcert');

## one of 'ENTERPRISE' | 'IIE' | 'APACHE' | 'ALIBABA' | 'WEBSITE'
$SERVERTYPE	= $tristate->param('servertype');

## Authority request only
$AUTHORITY	= $tristate->param('authority');
$CERTFORMAT	= $tristate->param('format');

## Checking for Boguous Systems ( POST method, REFERER doc, etc... )
if ($METHOD !~ /POST/i)
	{ &error_enroll('Bogus Web page!'); }

## Cut server root 
($REFERER = $HTTP_REFERER) =~ s/$SERVER_ROOT//;
($REFERER = $REFERER) =~ s/$SSL_SERVER_ROOT//;

## Start processing depending on operation,
## output MIME message is produced by subroutines

## cleaning up...
unlink ($TMPFILE, $MIMEFILE, $DUMPFILE);

## Set server specific things
## ( NONE... so far... )

## Filled FORM for user certification, confirmation page is generated

if ($OPERATION eq 'client-filled-form') {

	if( &checkFormOne() ne "") {
    		&printFormOne();
    		exit;   
	}

	&clientFilledForm();
}
elsif ($OPERATION eq 'client-confirmed-form') {
	if ($USER_AGENT !~ /Mozilla/i) {
		&error_enroll('Il Browser richiedente non viene supportato: ' . $USER_AGENT);
	}
	elsif ($USER_AGENT =~ /MSIE/i) {
	
		&sendPage( $browserError );
		
		exit;
	}
	else {
		## Netscape navigator enrollment
		
		print (logfile "\nNetscape navigator enrollment\n");	
		
		if ($NEWKEY eq '') {
			&error_enroll('Nessuna chiave data.');
		}
		
		## Modifiche MG
		## Modifiche MG per salvare la richiesta di certificazione su un file
		$NAME_FILE =$NAME;
		$NAME_FILE =~ s/\s/_/go;
		$NAME_FILE =~ s/['\(\)\+\?]/_/g;

		## $NAME_FILE = $CERT_REQ_DIR.$NAME_FILE."_req_".$$;
		$NAME_FILE = $CERT_REQ_DIR . &setFileName($NAME_FILE);

		## elimina eventuali ^M
		$NEWKEY =~ s/\015//g;

		## Estrazione della lunghezza della chiave
                $KEYLENGTH= &getKeyLength($NEWKEY);

 		open(en_file, ">$NAME_FILE") || die ("FATAL ERROR! Can not save to file $NAME_FILE!");
 		print(en_file "$NS_BEGIN_CERT_REQ");
		print(en_file "KEYLENGTH=$KEYLENGTH\n");
 		print(en_file "PASSWD=$PASSWD3\n");
 		print(en_file "EMAIL=$EMAIL\n");
 		print(en_file "CN=$NAME\n");
 		if ($ORG ne "") {
 			print(en_file "O=$ORG\n");
       		}
 		print(en_file "C=$COUNTRY\n");
 		print(en_file "$NS_BEGIN_PK");
 		print(en_file "$NEWKEY\n");
 		print(en_file "$NS_END_PK");
 		print(en_file "$NS_END_CERT_REQ");

		close(en_file);

		## Cifra il file in formato PKCS7
		## envelope_request($NAME_FILE);

		## end Modifiche
		
		$PHASE = 'CERT_REQ';
		&compose_answer(0);
		exit;

	}
	
	&client_enroll;
	} elsif ($OPERATION eq 'server-filled-form') {

	## Certificate Form for SERVER request.
	if ($SERVERTYPE eq 'UNKNOWN_SERVER') {
		&error_enroll('Il server richiedente non viene supportato.');
	};
	
	$PHASE = 'SERVER_PROLOG';
 	&server_enroll;
} elsif ($OPERATION eq 'server-confirmed-form') {

	# Confirmed FORM for server certification, certification is called now
	#Modifiche
	#if ($REFERER ne $SCRIPT_NAME) { &error_enroll('Please start with URL ' . $DOC_ROOT); }
	
	if ($SERVERTYPE eq 'UNKNOWN_SERVER') {
		&error_enroll('Il server richiedente non viene supportato.');
	}
	
	$PHASE = 'SERVER';
	#debug

	&server_enroll;

} elsif ($OPERATION eq 'sslclient-filled-form') {
	## Filled FORM for SSLCLIENT certification, confirmation page is generated
	$PHASE = 'SSLCLIENT_PROLOG';
	&sslclient_enroll;
}
elsif ($OPERATION eq 'sslclient-confirmed-form') {
	## Confirmed FORM for SSLCLIENT certification, certification is called now
	$PHASE = 'SSLCLIENT';
	&sslclient_enroll;
}
else {
	&error_enroll('Operazione invalida:' . $OPERATION);
};


## Close the CGI
&exit_enroll;


## Subroutines : certificate specific operations such as 
## generating certificate for client, SSLClient, Server, etc...

## Convert base64 coded block to VBS multiline style
sub base64_to_vbs
{
	local ($_) = @_ if @_;
	
#	$vbsline = "\n";
	
	@lines = split(/[\n]/, $_);
	foreach $line (@lines)
	{
		$vbsline = join('', $vbsline, '"', $line, '" & _', "\n");
	}
	$vbsline = join('', $vbsline, '""', "\n");
	
	return $vbsline;
}


## Call certification for Secure Server
sub server_enroll
{

	# call certification program that prints resulting MIME message to stdout or returns error code  
	
	if ($PHASE eq 'SERVER') {
	
		# decode and certify incoming certification request
		$REQUEST = &extract_request($NEWCERT);
		$CERTIFICATE = &extract_pem_certificate($REQUEST);

      		$BEGIN_SERVER_REQUEST="-----BEGIN ".$SERVERTYPE." SERVER CERTIFICATE REQUEST-----";
		$END_SERVER_REQUEST="-----END ".$SERVERTYPE." SERVER CERTIFICATE REQUEST-----";

		## print(logfile "Debug sono prima asn1_get_dn\n");

		%dn=asn1_get_dn($CERTIFICATE);
		$NAME=@dn{'CN'}; 

     		$NAME_FILE =$NAME;
     		$NAME_FILE =~ s/\./_/g;
     		## $DATE = `date +"%d%h%y"`;
     		## $NAME_FILE .=".$DATE";

		## $NAME_FILE =$CERT_REQ_DIR.$NAME_FILE.".".$$;
      		## $NAME_FILE =$CERT_REQ_DIR.$NAME_FILE."_req_".$$;
      		$NAME_FILE = $CERT_REQ_DIR . &setFileName($NAME_FILE);

		open(certserv,">$NAME_FILE");
		print(certserv "$BEGIN_SERVER_REQUEST\n");
		foreach $x ( keys %dn) {
			print(certserv "$x=@dn{$x}\n");
		}

	# elimina eventuali ^M
	$CERTIFICATE =~ s/\015//g;

	print(certserv "$NS_BEGIN_PK\n");
	print(certserv "$CERTIFICATE\n");
	print(certserv "$NS_END_PK\n");
	print(certserv "$END_SERVER_REQUEST\n");
	close(certserv);

	# print_exit;
	# print ("La Sua Richiesta e` stata registrata\n");

	envelope_request($NAME_FILE);

	$PHASE  = 'CERT_REQ'; 
	&compose_answer($? >> 8);
	exit;
		
	## Era un elsif, ma non ho trovato l'if corrispondente!!!!
	} elsif ($PHASE eq 'SERVER_PROLOG') {
	
		# decode and show incoming certification request
		
		$REQUEST = &extract_request($NEWCERT);
		$CERTIFICATE = &extract_pem_certificate($REQUEST);
		
		$CERTDUMP = &asn1_print($CERTIFICATE);
		
		# generate confirmation page
		open(tmpfile, ">$MIMEFILE") || die ('FATAL ERROR! Stopped');
		
		&print_header(tmpfile);


		#modificato

		$SCRIPT_NAME="$CGI_ROOT";
		
		$oldfh = select(tmpfile);
		print << x 1;   # print up to first empty line
		<!---- HTML code ---->
		<B>La richiesta appare inoltrata correttamente.</B></TD></TR>
		<FORM METHOD=POST ACTION="$SCRIPT_NAME">
		<TR><TD ALIGN=LEFT COLSPAN=2><I>The Certificate Request contains:</I></TD></TR>
		<TR><TD ALIGN=LEFT COLSPAN=2 WIDTH=100><SMALL><BLOCKQUOTE><B>
		<PRE>$CERTDUMP</PRE>
		</BLOCKQUOTE></B></SMALL><BR></TD></TR>
		<TR><TD HEIGHT=100 ALIGN=TOP ><SMALL>Abbiate cura di confrontare le informazioni mostrate qui sopra con quelle desiderate per il vostro server.<BR>
		In caso affermativo, premere <B>Continua</B> per procedere nella certificazione.</SMALL></TD>
		<TD HEIGHT=100 ALIGN=MIDDLE><INPUT TYPE=SUBMIT VALUE="Continua...">
		<INPUT TYPE=HIDDEN NAME="operation" VALUE="server-confirmed-form">
		<INPUT TYPE=HIDDEN NAME="servertype" VALUE="$SERVERTYPE">
		<INPUT TYPE=HIDDEN NAME="newcert" VALUE="$REQUEST">
		</TD></TR></FORM></TABLE>

		#<!---- code ends with EMPTY LINE --->
		select($oldfh);
		
		&print_footer(tmpfile);
		close(tmpfile);
		
		&compose_answer(0);
	}
}

#Enrollment for SSLCLIENT
sub sslclient_enroll  {

	# call certification program that prints resulting MIME message to stdout or returns error code  
	
	if ($PHASE eq 'SSLCLIENT') {
	
		# decode and certify incoming certification request
		$REQUEST = &extract_request($NEWCERT);
		$CERTIFICATE = &extract_pem_certificate($REQUEST);

		$BEGIN_SSLCLIENT_REQUEST="-----BEGIN SSL CLIENT CERTIFICATE REQUEST-----";
		$END_SSLCLIENT_REQUEST="-----END SSL CLIENT CERTIFICATE REQUEST-----";

		## print(logfile "Debug sono prima asn1_get_dn\n");

		%dn=asn1_get_dn($CERTIFICATE);
		$NAME=@dn{'CN'}; 

     		$NAME_FILE =$NAME;
		## $NAME_FILE =~ s/\./_/g;
      		$NAME_FILE =~ s/\s/_/go;
      		$NAME_FILE =~ s/['\(\)\+\?]/_/go;

		##'
     		#$DATE = `date +"%d%h%y"`;
     		#$NAME_FILE .=".$DATE";
		## $NAME_FILE =$CERT_REQ_DIR.$NAME_FILE.".".$$;
		
		$NAME_FILE =$CERT_REQ_DIR.$NAME_FILE."_req_".$$;

		open(certserv,">$NAME_FILE");
		print(certserv "$BEGIN_SSLCLIENT_REQUEST\n");
		foreach $x ( keys %dn) {
			print(certserv "$x=@dn{$x}\n");
		}
      
      		## elimina eventuali ^M
      		$CERTIFICATE =~ s/\015//g;

		print(certserv "$NS_BEGIN_PK");
		print(certserv "$CERTIFICATE\n");
		print(certserv "$NS_END_PK");
		print(certserv "$END_SSLCLIENT_REQUEST\n");
		close(certserv);

		## print_exit;
		## print ("La Sua Richiesta e` stata registrata\n");

      		envelope_request($NAME_FILE);

      		$PHASE  = 'CERT_REQ'; 
		&compose_answer($? >> 8);
		exit;
		
	} elsif ($PHASE eq 'SSLCLIENT_PROLOG') {
	
		# decode and show incoming certification request
	

		$REQUEST = &extract_request($NEWCERT);
		$CERTIFICATE = &extract_pem_certificate($REQUEST);
		
		$CERTDUMP = &asn1_print($CERTIFICATE);
		
		# generate confirmation page
		open(tmpfile, ">$MIMEFILE") || die ('FATAL ERROR! Stopped');
		
		&print_header(tmpfile);


		#modificato

		$SCRIPT_NAME="$CGI_ROOT";
		
		$oldfh = select(tmpfile);
		print << x 1;   # print up to first empty line
		<!---- HTML code ---->
		<B>La richiesta appare inoltrata correttamente.</B></TD></TR>
		<FORM METHOD=POST ACTION="$SCRIPT_NAME">
		<TR><TD ALIGN=LEFT COLSPAN=2><I>The Certificate Request contains:</I></TD></TR>
		<TR><TD ALIGN=LEFT COLSPAN=2 WIDTH=100><SMALL><BLOCKQUOTE><B>
		<PRE>$CERTDUMP</PRE>
		</BLOCKQUOTE></B></SMALL><BR></TD></TR>
		<TR><TD HEIGHT=100 ALIGN=TOP ><SMALL>Abbiate cura di confrontare le informazioni mostrate qui sopra con quelle desiderate per il vostro server.<BR>
		In caso affermativo, premere <B>continua</B> per procedere nella certificazione.</SMALL></TD>
		<TD HEIGHT=100 ALIGN=MIDDLE><INPUT TYPE=SUBMIT VALUE="Continua...">
		<INPUT TYPE=HIDDEN NAME="operation" VALUE="sslclient-confirmed-form">
		<INPUT TYPE=HIDDEN NAME="newcert" VALUE="$REQUEST">
		</TD></TR></FORM></TABLE>

		#<!---- code ends with EMPTY LINE --->
		select($oldfh);
		
		&print_footer(tmpfile);
		close(tmpfile);
		
		&compose_answer(0);
	}
}





# Enrollment exit with clean up 
sub exit_enroll
{
	
	unlink ($TMPFILE, $MIMEFILE, $DUMPFILE);
	exit;
}

# Enrollment Error with exit 
sub error_enroll
{
	local ($message) = @_ if @_;
	
	#
	# HTML output for WWW client	
	
	print("Content-type: text/html\n\n");
	$VENDOR_LOGO = $ERROR_LOGO;
	&print_header(STDOUT);
	
	print << x 1;   # print up to first empty line
	<!---- HTML code ---->
	<BLOCKQUOTE><BR><BR><BR><H2>Si &egrave; verificato un errore</H2><BR>Il messaggio di errore &egrave;: <B>$message</B><BR><BR><BR>
	Verificare i dati immessi e provare nuovamente o contattate l'help desk :<BR><BR>
	<BLOCKQUOTE><A HREF="mailto:$SUPPORT_EMAIL">CA Help Desk</A><BR>Tel: $SUPPORT_FON<BR>Fax: $SUPPORT_FAX
	</BLOCKQUOTE><BR><BR></TD></TR></TABLE>

	#<!---- code ends with EMPTY LINE --->
	&print_footer(STDOUT);
	
	#
	# email to admin if internal error occured
	
	if ($message =~ /SERVICE NOT AVAILABLE/i) {
	
		open(email, "| $MAILPROG") || die ('FATAL ERROR! Stopped');
	
		$oldfh = select(email);
		print << x 1;   # print up to first empty line
------------------------------------
 TrustFactory Internal Error	$message
------------------------------------

 Check the TrustFactory Log for details:

	file:$ENROLLLOG
	
	IP	$ENV{'REMOTE_ADDR'}
	UA	$ENV{'HTTP_USER_AGENT'}
	URL	$ENV{'HTTP_REFERER'}

----------------------------------------------------------------
 This email was automatically generated by the Web server script
 http[s]://$ENV{'SERVER_NAME'}$SCRIPT_NAME
----------------------------------------------------------------

		#<!---- code ends with EMPTY LINE --->
		select($oldfh);
		
		close(email);
	}
	
	&exit_enroll;
}

##' Enrollment Return code check, Web page or Certificate composer
sub compose_answer
{
	local ($_) = @_ if @_;
	if (/^0/) {
	
		open(tmpfile, "<$MIMEFILE");
		while (read(tmpfile, $buffer, 1024)) { $mimebody .= $buffer; }
		close(tmpfile);
		
		&trace_string2file($mimebody, $TRACEFILE);

		if ($PHASE eq 'SERVER_PROLOG')  { 
        		print("Content-type: text/html\n\n");
        		print("$mimebody");
       		} 
   		elsif ($PHASE eq 'NETSCAPE_PROLOG') {
       			print("Content-type: text/html\n\n");
        		print("$mimebody");
       		}
  		elsif ($PHASE eq 'MICROSOFT_PROLOG') {
      			print("Content-type: text/html\n\n");
      			print("$mimebody");
     		}	
	  	elsif ($PHASE eq 'SSLCLIENT_PROLOG')  {
	  		print("Content-type: text/html\n\n");
	  		print("$mimebody");

		}
		elsif ($PHASE eq 'CERT_REQ') {
   			&printSuccessPage();
		}
	} else {
	
		if    (/^255/)	{ $message = "0xff: ERROR_CERTIFY"; }
		elsif (/^254/)	{ $message = "0xfe: ERROR_BUILD_OUTPUT"; }
		elsif (/^253/)	{ $message = "0xfd: ERROR_WRITE_OUTPUT"; }
		elsif (/^252/)	{ $message = "0xfc: ERROR_OPEN_CA"; }
		elsif (/^251/)	{ $message = "0xfb: ERROR_READ_INPUT"; }
		elsif (/^250/)	{ $message = "0xfb: ERROR_PARSE_INPUT"; }
		elsif (/^249/)	{ $message = "0xfb: ERROR_EXTENSIONS"; }
		else		{ $message = "$_: SERVICE NOT AVAILABLE"; }

		&error_enroll($message);
	}
}


## Decode ASN.1 certification request object and return print out
sub asn1_print
{
		
	local ($b64object) = @_ if @_;
	
	open(asn1show, "| $SECUDE_ASN1SHOW '-R' 2>> $DUMPFILE") || die ('FATAL ERROR! Stopped');
		
	print(asn1show "$b64object");
	close(asn1show);
	
	$_ = $? >> 8;
	
	if (/^0/) {
	
		open(dumpfile, "<$DUMPFILE");
		while (<dumpfile>) { $printed .= $_; }
		close(dumpfile);
		
		@dump = <$DUMPFILE>;
		
		return $printed;
	}
		
	elsif (/^255/)	{ $message = "0xff: ASN1_ERROR_SHOW"; }
	elsif (/^254/)	{ $message = "0xfe: ASN1_ERROR_UNKNOWN_OBJECT"; }
	elsif (/^253/)	{ $message = "0xfd: ASN1_ERROR_NO_ASN1"; }
	else		{ $message = "$_: ASN1_UNKNOWN ERROR"; }

	&error_enroll($message);
}

## Modifiche MG
sub asn1_get_dn
{
		
	local ($b64object) = @_ if @_;
	
	open(asn1show, "| $SECUDE_ASN1SHOW '-R' 2>> $DUMPFILE") || die ('FATAL ERROR! Stopped');
		
	print(asn1show "$b64object");
	close(asn1show);
	
	$_ = $? >> 8;
	
	
		open(dumpfile, "<$DUMPFILE");
		while (<dumpfile>) { 
			  if(/SubjectName/) {
							 last;
							 }
		}
		close(dumpfile);
		
	chomp;
	$DN=$_;
	$DN =~ s/SubjectName:\s*//go;
	$DN =~ s/^\s*(.*?)\s*$/$1/;
	$_=$DN;
#	print("$DN\n");
        s/,\s/,/g;
	%vetc = split(/[,=]/);
	foreach $x ( keys %vetc) {
        $x =~ s/^\s*//g;
	}
	unlink($DUMPFILE);
	return %vetc;

}

#Modifica MG
# routine per cifrare le richieste di certificazione con chiave della RA o CA
sub envelope_request
{

 local ($REQUEST) = @_ if @_;
# Il file adesso e` cifrato pkcs7

$WRAPFILE="$REQUEST.p7";

#Estrazione dei dname

$ENROLLRA_DNNAME= &extract_ra_dname;


if (($err = system "$SECUDE_CIFEN $REQUEST | $SECUDE_CIFWRAP $ENROLLRA_DNNAME -p $ENROLL_CAFE > $WRAPFILE") != 0) {
  &error_enroll("$err: Impossibile eseguire  $SECUDE_CIFEN $REQUEST | $SECUDE_CIFWRAP $ENROLLRA_DNNAME -p $ENROLL_CAFE > $WRAPFILE"); }
 
# '$SECUDE_ENCODE $WRAPFILE > $NAME_FILE';

unlink($REQUEST) if (-e $WRAPFILE);
}

## Modifica di Massimiliano Pala per l'RA on the Web.
## Utilizzo di SSLeay
sub envelope_request_new {
	local ( $REQUEST ) = @_ if @_;
	my $SSLEAY = '/usr/local/ssl/bin/ssleay ';
	my $KEY    = '/usr/local/ssl/private/www-cli.key';

	$cmd = "$SSLEAY enc -in $REQUEST -out $REQUEST.p7 -e -k $KEY -des3";
	system( $cmd );

	open FD, ">/tmp/prova.tmp";
		print FD "Request : $REQUEST\n";
		print FD "Command : $cmd\n";
	close FD;

	return;
};


# print HTML header to file
sub print_header
{
	local ($file) = @_ if @_;

	$oldfh = select($file);
	print << x 1;   
	<!---- HTML code ---->
	<HTML><META HTTP-EQUIV="Pragma" CONTENT="no-cache"><TITLE>Digital ID Registration Center</TITLE>
<BODY BGCOLOR="white">
<P>
  <TABLE BORDER=0 WIDTH=100% CELLPADDING=5 CELLSPACING=1>
        <TR><TD ALIGN=LEFT COLSPAN=2><FONT SIZE=-1><B><I>NOTA IMPORTANTE</I></B>:


	#<!---- code ends with EMPTY LINE --->
	select($oldfh);
}

# print HTML footer to file
sub print_footer
{
	local ($file) = @_ if @_;
	
	$oldfh = select($file);
	print << x 1;   # print up to first empty line
	<!---- HTML code ---->
<DIV ALIGN=CENTER>
<EM>La $CA_NAME &egrave; gestita dalla sezione <A HREF="http://altea.comune.modena.it/">Security and Marketing del Comune di Modena.</A>
</EM>
<HR WIDTH="80%" SIZE="4pt">
</DIV>
<EM> $CA_NAME <BR>
<A HREF="mailto:$SUPPORT_EMAIL">$SUPPORT_EMAIL</A></EM>
<BR CLEAR=ALL>
<P>

	#<!---- code ends with EMPTY LINE --->
	select($oldfh);
}

sub trace_string2file
{
	local ($string, $file) = @_ if @_;
# print("\n sono in trace_string2file\n");

#	print ("\n apro >$file\n");
	open(tracefile, ">$file") || die ('FATAL ERROR! Stopped');
	print tracefile ("$string");
#	print ("$string","\n");
	close(tracefile);
}


sub msie_print_genscript
{

	local ($script) = @_ if @_;
	
	select($script);
	print << x 1;   # print up to first empty line
	<!---- VBS code ---->
	<OBJECT
	    classid="clsid:33BEC9E0-F78F-11cf-B782-00C04FD7BF43"
	    codebase="$SERVER_ROOT/cli/microsoft/certenr3.dll"
	    id=certHelper>
	</OBJECT>
	<SCRIPT LANGUAGE=VBS>
	    Sub Generate_OnClick
	        Set HtmlForm = Document.MsieForm
	        sessionId = "$SESSIONID"
	        szName = "$CNAME"
	        On Error Resume Next
	        sz10 = certHelper.GenerateKeyPair(sessionId, FALSE, szName, 0, "ClientAuth", FALSE, TRUE, 1)
	        theError = Err.Number
	        On Error Goto 0
	        if (sz10 = Empty OR theError <> 0) Then
	            sz = "The error '" & Hex(theError) & "' occurred." & chr(13) & chr(10) & "Your credentials could not be generated."
	            result = MsgBox(sz, 0, "Credentials Enrollment")
	            Exit Sub
	        end if
	        HtmlForm.Newkey.Value = sz10
	        HtmlForm.Submit
	        Exit Sub
	    End Sub
	</SCRIPT>

	#<!---- code ends with EMPTY LINE --->
	select($oldfh);
}


sub print_exit
{
	print "\n 
   <HTML>\n
<BODY>\n
&nbsp;\n
<H1>\n
La sua richiesta e` stata registrata!</H1>\n
\n
</BODY>\n
</HTML> \n"
  

}

sub extract_request
{
        local ($_) = @_ if @_;

        $begin = '0';

        @lines = split(/[\n]/, $_);
        foreach $line (@lines)
        {
                if ($line =~ /$PEM_BEGIN/i) { $begin = '1'; }
                if ($begin eq '0') { next; }

                $pemformat = join("\n", $pemformat, $line);

                if ($line =~ /$PEM_END/i) { return $pemformat; }
        }

        return $_;
}

sub extract_pem_certificate
{
       local ($_) = @_ if @_;

        $begin = '0';

        @lines = split(/[\n]/, $_);
        foreach $line (@lines)
        {
                if ($line =~ /$PEM_MESSAGE_BEGIN/i)     { $cert = &pem_originator_certificate($_); return $cert; }
                elsif ($line =~ /$PEM_BEGIN/i)          { $cert = &pem_like_certificate($_); return $cert; }
        }

        return $_;
}


# Estrae i dname dei destinatari dei messaggi cifrati

sub extract_ra_dname
{
   for ($i=0; $i <= $#ENROLLCA_DNNAME; $i++) {
   $OPT=$OPT." -r ".$ENROLLCA_DNNAME[$i];
   }

   return $OPT
}

## Data la richiesta in formato base64 estrae con asn1dump
## il campo KEYLENGTH ritorna la lunghezza delle richieste

sub getKeyLength {
   ## local ($TOBECERTIFIED) = @_ if @_;

   ## Modified by Massimiliano Pala (10-12-1998)
   my $DUMP_FILE;
   my @keys;

   @keys = @_;

   $TOBECERTIFIED = $keys[0];

   $DUMP_FILE="/tmp/.dump" . $$;
   $LOG="/tmp/.log_ca";


   ## Eseguo il dump del file
   open(execdump, "| $SECUDE_DUMP > $DUMP_FILE 2> /dev/null");
   print(execdump "$TOBECERTIFIED\n");
   close(execdump);


   ## Estraggo i campi contenenti BIT STRING
   open (fd, "< $DUMP_FILE") || die ("non posso aprire il file $DUMP_FILE");

   while (<fd>) {
     if (/BIT STRING number of bits/) {
        $KEY_LENGHT=$_;
                                  }
                }
   close(fd);
   
   @key=split / /,$KEY_LENGHT;
   $LAST=pop(key);
   chomp $LAST;
   
   unlink ($DUMP_FILE );
   return $LAST;
}

## Ritorna il nome del file avente il seguente formato
## Nome_Cognome~pid_DATE00-00-0000_req.p7 
sub setFileName {

   ## local ($NAME_FILE) = @_ if @_;

   ## Modified by Massimiliano Pala (10-12-1998)
   my $NAME_FILE;
   my @keys;

   @keys = @_;

   $NAME_FILE =  $keys[0]; 

   $NAME_FILE =~ s/\s/_/go;
   $NAME_FILE=~ s/['\(\)\+\?]/_/g;

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $date = "$mday-".($mon+1)."-".(1900+$year);
   $DATE="DATE"."$date";

   $NM = $NAME_FILE . "\~"   . $$ . "_" . $DATE . "_req";
   return $NM;
}

# segnala se le stringhe ricevute non sono PrintableString
# restituisce:
#    0 (falso) se la stringa e` PrintableString
#    il primo carattere non PrintableString altrimenti 

sub isNotPrintableString{
  my $validchars = join "", (a..z,A..Z,0..9,' ()+,-./=?',"'");
  my $ret = 0;

  foreach $c (split //, join "", @_){
    if (index($validchars,$c) < 0 ) { $ret = $c; last; }
  }
  $ret;
}

## Sezione delle Subroutines
## 
## Qui sono conservate le routines che possono fare comodo nella
## stesura dei CGI : dalle funzioni per la verifica della firma,
## alla generazione della form da firmare ( automatica ), ecc...

## Generate Input Fields
sub printFormOne {
	print "Content-Type: text/html\n\n";
	
	print $tristate->start_html(-title=>'Richiesta Certificato presso il Comune di Modena',
			  -author=>'Massimiliano Pala <madwolf@comune.modena.it>',
			  -BGCOLOR=>'white',
			  -TEXT=>'#264A8D',
			  -LINK=>'#A80C00',
			  -VLINK=>'#730000',
			  -ALINK=>'#000088');

	print $tristate->start_multipart_form(-method=>'POST',
				-action=>$tristate->self_url());
				
	## Generate the Input Fields				
	open FD, "<$formFile" or die "Can not load $formFile!";
	while ( $p = <FD> ) {
	    $form .= $p;
	}
	close FD;
	
	## Substitute the parameters with their true values
	$i = 0;
	foreach $p (@myparnames) {
	    $match = "\\$p";
	    $mysub = $myparams[$i];
	    $form =~ s/$match/$mysub/g;
	    $i += 1;
	}
	
	print $form;

	## print $tristate->endform;
	## print $tristate->endPage;

	return;
}

sub printFormTwo {
	print "Content-Type: text/html\n\n";
	
	print $tristate->start_html(-title=>'Richiesta Certificato al Comune di Modena',
			  -author=>'Massimiliano Pala <madwolf@comune.modena.it>',
			  -BGCOLOR=>'white',
			  -TEXT=>'#264A8D',
			  -LINK=>'#A80C00',
			  -VLINK=>'#730000',
			  -ALINK=>'#000088');

	print $tristate->start_multipart_form(-method=>'POST',
				-action=>$tristate->referer() );
				
	## Generate the Input Fields				
	open FD, "<$formFile2" or die;
	while ( $p = <FD> ) {
	    $form .= $p;
	}
	close FD;
	
	## Substitute the parameters with their true values
	$i = 0;
	foreach $p (@myparnames) {
	    $match = "\\$p";
	    ## $mysub = $myparams[$i]; 
	    ## Get the Name for each parameter
	    ($mysub) = 
	    	$p =~ /([a-zA-Z0-9\_]+)/;

	    ## Get the Parameter Value from the Form
	    $myValue = $tristate->param($mysub);
 	    
	    ## Substitute the parameters in the form with the extracted values
	    $form =~ s/$match/$myValue/g;
	    
	    ## No more Needed
	    ## $i += 1;
	}
	
	print $form;

	return;
}

sub sendPage {
	my @keys;
	my $ret;
	@keys = @_;
	
	print "Content-Type: text/html\n\n";

	$fileName  = "$baseErrorPath";
	$fileName .= $keys[0];

	open ( FD, "$fileName" ) || print "$fileError"."($fileName)";
	while (<FD>) {
		print $_;
	};
	close FD;
	
	return; 
}

sub printSuccessPage {
	&sendPage($successPage);
	return;
}

sub checkFormOne {

	my $ret ="";
	
	$ret .= $tristate->newInputCheck( %par1 );
	## $ret .= $tristate->newInputCheck( %par2 );
	$ret .= $tristate->newInputCheck( %par3 );
	$ret .= $tristate->newInputCheck( %par4 );
	$ret .= $tristate->newInputCheck( %par5 );
	$ret .= $tristate->newInputCheck( %par6 );
	$ret .= $tristate->newInputCheck( %par7 );
	$ret .= $tristate->newInputCheck( %par8 );
	$ret .= $tristate->newInputCheck( %par9 );
	## $ret .= $tristate->newInputCheck( %par10 );
	## $ret .= $tristate->newInputCheck( %par11 );
	## $ret .= $tristate->newInputCheck( %par12 );
	## $ret .= $tristate->newInputCheck( %par13 );
	## $ret .= $tristate->newInputCheck( %par14 );

	$m = "<BR>|Campo|Giusto|OK|[\ \(\)]";
	$ret =~ s/$m//g;

	return $ret;
};

sub clientFilledForm {
	if ($USER_AGENT !~ /Mozilla/i) {
		&error_enroll('Il browser richiedente non viene supportato: ' . $USER_AGENT);
	}
	elsif ($USER_AGENT =~ /MSIE/i)	{
		&sendPage( $browserError );
		&error_enroll('Non si possono Utilizzare i Browser Microsoft, utilizzare Netscape 4.04 ( o successivo )');
	}
	else {
		# Netscape Navigator form check
		print(logfile "\nREFERER= $REFERER e NS_URL = $NS_URL\n");
		
		## Rem by madwolf	
		# if ($REFERER ne $NS_URL) 	{ &error_enroll('Utilizzare la pagina per i Browser Netscape.'); }
	
		if ("$PASSWD" ne "$PASSWD2") {
			&error_enroll('I due PIN non coincidono. Per favore riprova.');
		}

		# OK
		$PHASE = 'NETSCAPE_PROLOG';
		$VENDOR_LOGO = $NS_LOGO;
		$PRODUCT_NAME = $NS_NAME;
	}
	
	$TRUST_LOGO = $CLIENT_LOGO;
	$STATUS_LOGO = $CONFIRM_LOGO;

	&printFormTwo();
} 

sub client_enroll
{

	# call certification program that prints resulting MIME message to stdout or returns error code  
	
	if ($PHASE eq 'NETSCAPE_PROLOG') {

		## Inserted by madwolf
		## $CGI_ROOT="/cgi-bin/enrollid.cgi";	

		open(tmpfile, ">$MIMEFILE") || die ('FATAL ERROR! Stopped');
		&print_header(tmpfile);
		
#		<FORM METHOD=POST ACTION="$SCRIPT_NAME">
		$oldfh = select(tmpfile);
		print << x 1;   # print up to first empty line
		<!---- HTML code ---->
		<B>Questi sono i dati per i quali sta per essere emesso un certificato</B></TD></TR>
		<FORM METHOD=POST ACTION="$CGI_ROOT">
		<TR><TD WIDTH=30% ALIGN=RIGHT >Nome:</TD><TD WIDTH=70% ALIGN=LEFT><B>$FIRST_NAME</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT >Cognome:</TD><TD WIDTH=70% ALIGN=LEFT><B>$LAST_NAME</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT >Organizzazione:</TD><TD WIDTH=70% ALIGN=LEFT><B>$ORG</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT >Nazione:</TD><TD WIDTH=70% ALIGN=LEFT><B>$COUNTRY</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT >E-Mail:</TD><TD WIDTH=70% ALIGN=LEFT><B>$EMAIL</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT  ><B>Key size:</B></TD>
		<TD WIDTH=70% ALIGN=LEFT><SMALL><KEYGEN NAME="newkey" CHALLENGE="$PASSWD"></SMALL><BR></TD></TR>
		<TR><TD HEIGHT=100 ALIGN=TOP ><SMALL>Abbiate cura di confrontare le informazioni mostrate con quelle desiderate.<BR>
		In caso coincidano, premere <B>Continua</B> per procedere nella creazione di una nuova coppia di chiavi. <BR>Altrimenti tornate alla pagina precedente per cambiare i dati.</SMALL></TD>
		<TD HEIGHT=100 ALIGN=MIDDLE ><INPUT TYPE=SUBMIT VALUE="Continua...">
		<INPUT TYPE=HIDDEN NAME="operation" VALUE="client-confirmed-form">
		<INPUT TYPE=HIDDEN NAME="first_name" VALUE="$FIRST_NAME"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="last_name" VALUE="$LAST_NAME"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="org" VALUE="$ORG"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="country" VALUE="$COUNTRY">
		<INPUT TYPE=HIDDEN NAME="email" VALUE="$EMAIL"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="passwd3" VALUE="$PASSWD"></TD></TR>
		</TD></TR></FORM></TABLE>

		#<!---- code ends with EMPTY LINE --->
		select($oldfh);
		
		&print_footer(tmpfile);
		close(tmpfile);
		
		&compose_answer(0);
	}
	
	#
	# MSIE
	#
	 elsif ($PHASE eq 'MICROSOFT_PROLOG') {
	
		srand();
		($SESSIONID = rand()) =~ tr/.//d;
#		$CNAME = "EM=$EMAIL, CN=$NAME, O=$ORG, C=$COUNTRY";
		$CNAME = "CN=$NAME, O=$ORG, C=$COUNTRY";
		$NOME=$NAME;
		
		open(tmpfile, ">$MIMEFILE") || die ('FATAL ERROR! Stopped');
		&print_header(tmpfile);
		
		# ActiveX script for request generation
		&msie_print_genscript(tmpfile);
		
		$oldfh = select(tmpfile);
		print << x 1;   # print up to first empty line
		<!---- HTML code ---->
		<B>Questi sono i dati per i quali sta per essere emesso un certificato.</B></TD></TR>
		<FORM NAME="MsieForm" METHOD=POST ACTION="$SCRIPT_NAME">
		<TR><TD WIDTH=30% ALIGN=RIGHT>Nome:</TD><TD WIDTH=70% ALIGN=LEFT><B>$FIRST_NAME</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT>Cognome:</TD><TD WIDTH=70% ALIGN=LEFT><B>$LAST_NAME</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT>Organizzazione:</TD><TD WIDTH=70% ALIGN=LEFT><B>$ORG</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT>Nazione:</TD><TD WIDTH=70% ALIGN=LEFT><B>$COUNTRY</B></TD></TR>
		<TR><TD WIDTH=30% ALIGN=RIGHT>E-Mail:</TD><TD WIDTH=70% ALIGN=LEFT><B>$EMAIL</B></TD></TR>
		<TR><TD HEIGHT=100 ALIGN=TOP ><SMALL>Abbiate cura di confrontare le informazioni mostrate qui sopra con quelle desiderate.<BR>
		In caso affermativo, premere <B>Continua</B> per procedere nella creazione di una nuova coppia di chiavi.</SMALL></TD>
		<TD HEIGHT=100 ALIGN=MIDDLE><INPUT TYPE="BUTTON" NAME="Generate" VALUE="Continua..">
		<INPUT TYPE=HIDDEN NAME="operation" VALUE="client-confirmed-form">
		<INPUT TYPE=HIDDEN NAME="passwd1" VALUE="$PASSWD">
		<INPUT TYPE=HIDDEN NAME="sessionid" VALUE="$SESSIONID">
		<INPUT TYPE=HIDDEN NAME="newkey" VALUE="$NAME">
		<INPUT TYPE=HIDDEN NAME="first_name" VALUE="$FIRST_NAME"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="last_name" VALUE="$LAST_NAME"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="org" VALUE="$ORG"></TD></TR>
		<INPUT TYPE=HIDDEN NAME="country" VALUE="$COUNTRY">
		<INPUT TYPE=HIDDEN NAME="email" VALUE="$EMAIL"></TD></TR>
		</TD></TR></FORM></TABLE>

		#<!---- code ends with EMPTY LINE --->
		select($oldfh);
		
		&print_footer(tmpfile);
		close(tmpfile);
		
		&compose_answer(0);
	}
}
 
