#!/usr/bin/perl

## CRL List Manager - Version 0.01.
## (c) 1998 by Massimiliano Pala
## All rights Reserved.

## Flush the Output stream
$|=1;

print "Content-type: text/html\n\n";

## Variables Definition
$rilDir  = 'certs/';
$basedoc = 'forms/ril.html';
$getID_url = '/cgi-bin/getID?type=email';

## Get the Directory Listing in the @rilList List Variable
opendir ( CERTS , "$rilDir" );
	@rilList = grep( /pem/, readdir( CERTS ) );
closedir( CERTS );

## @rilList2 = sort numerically @rilList;
@rilList2 = sort @rilList;

## Get the base Page ( got in $page variable )
open ( FD, "$basedoc" ) || die ( "File not Found : $basedoc" );
while( $temp = <FD> ) {
	$page .= $temp;
};

close ( FD );

## Create base Table and Date to substitute in the $page
## at the '$table' and '$aggiornamento' we find in the 
## $page variable ( read from the $basedoc file )
$aggiornamento = `date`;
chop( $aggiornamento );

$table = createTable();

## Process all Files
foreach $file (@rilList2) {
	$table .= addFile( $file );
}

## Close the Table
$table .= "</TABLE>\n\n";
$table .= "<!--- End of the madcert.pl Generated Table ---!>";

## Substitute the Variables in the $page
$page = &subVars( $page, '$aggiornamento', $aggiornamento );
$page = &subVars( $page, '$table', $table );

print "$page";

exit 0;

## Subroutines Section:
## ====================
##
## Main subroutines are the createTable wich creates the base
## Table with the main row ( with Descriptions ), the addFile
## wich adds a Row with the file description and date of 
## creations and so on, and the subVars ehich substitutes
## the variables name contained in the $page var with their
## correct values.

sub createTable {
	my @keys;
        my $ret;
        @keys = @_; 

	## No parameters needed
	$ret  = "\n".'<!--- Table Generated by rilCert.pl (c) 1998 by Massimiliano Pala ---!>'."\n";
	$ret .= '<TABLE BORDER=0 CELLSPACING=5 CELLPADDING=2 WIDTH="100%" BGCOLOR="#FFFFFF" NOSAVE >'."\n";
	$ret .= '<TR BGCOLOR="#DDCCFF" NOSAVE>'."\n";
	$ret .= '<TD NOSAVE><B>Ser</B></TD>'."\n";
	$ret .= '<TD><B>User</B></TD>'."\n";
	$ret .= '<TD><B>Issued</B></TD>'."\n";
	$ret .= '<TD><B>E-Mail</B></TD>'."\n";
	$ret .= '</TR>'."\n";

	return $ret;
}

sub addFile {
	my @keys;
        my @filestats;
        my $ret;
        @keys = @_; 

	my $fileName = $keys[0];
	my $certificato, $subject;

        open( FD , "$rilDir"."$fileName" ) || return;
        	@filestats = stat ( FD );
		while ( $line = <FD> ) {
			$certificato .= $line;
		};
        close ( FD );

	( $subject )  = ( $certificato =~ /Subject([^\n]+)/i );
	( $num )      = ( $fileName =~ /([\d\w]+)/ );
	( $titolare ) = ( $subject =~ /CN\=([^\/,]+)/i );
	( $email )    = ( $subject =~ /EMAIL\=([^\/,]+)/i );
	( $created )  = ( $certificato =~ /Not Before: ([^\n]+)/i );

        @T = localtime($filestats[9]);
        ## $created = sprintf("%d/%d/%d",$T[3],$T[4]+1,$T[5]);

	$ret .= '<TR BGCOLOR="#FFFFFF" NOSAVE>'."\n";
	$ret .= '<TD>'. "<A HREF=\"$getID_url&serial=". "$num";
	$ret .= "\" ALT=\"Download Cert\">$num</A>".'</TD>' ;
	## $ret .= "$fileName". "\" ALT=\"Download Cert\">$num</A>".'</TD>' ;
	$ret .= '<TD>'. "$titolare" . '</TD>';
	$ret .= '<TD>'. "$created" . '</TD>';
	$ret .= '<TD>'. "<A HREF=\"mailto:$email\">$email</A>" . '</TD>';

	return $ret;
}

sub subVars {
	my @keys;
        my $ret;
        @keys = @_; 

	$pageVar = $keys[0];
	$varName = $keys[1];
	$var	 = $keys[2];

	$match = "\\$varName";
        $pageVar =~ s/$match/$var/g;

	return $pageVar;
}

sub numerically {
	( $w ) = ( $a =~ /([0-9]+)/ );
	( $e ) = ( $b =~ /([0-9]+)/ );
	$w <=> $e;
}

